From 76156f922a75e0447a555488b444054caa53b342 Mon Sep 17 00:00:00 2001
From: Luca Capello <luca@pca.it>
Date: Wed, 9 Mar 2011 23:42:27 +0100
Subject: [PATCH] acpi.c: add workaround for battery status when using -s

---
 ChangeLog |    2 ++
 acpi.c    |    7 +++++++
 2 files changed, 9 insertions(+), 0 deletions(-)

diff --git a/ChangeLog b/ChangeLog
index 4a4b4d0..dac63a5 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -2,6 +2,8 @@
 
  * main.c: use spaces to align -h output
 	(Debian bug #617548)
+ * acpi.c: add workaround for battery status when using -s
+	(Debian bug #617611)
 
 2010-03-28  Michael Meskes  <meskes@debian.org>
 
diff --git a/acpi.c b/acpi.c
index 336a91c..b437ff0 100644
--- a/acpi.c
+++ b/acpi.c
@@ -267,6 +267,7 @@ void print_battery_information(struct list *batteries, int show_empty_slots, int
 	int percentage;
 	char *state = NULL, *poststr;
 	int type_battery = TRUE;
+	int type_total = 1;
 	char capacity_unit[4] = "mAh";
 
 	fields = battery->data;
@@ -309,6 +310,7 @@ void print_battery_information(struct list *batteries, int show_empty_slots, int
 		    get_unit_value(value->value) / 1000;
 	    } else if (!strcmp(value->attr, "type")) {
 		type_battery = (strcasecmp(value->value, "battery") == 0);
+		type_total++;
 	    } else if (!strcmp(value->attr, "charging state") || !strcmp(value->attr, "State")) {
 		state = value->value;
 	    } else if (!strcmp(value->attr, "voltage_now")) {
@@ -319,6 +321,7 @@ void print_battery_information(struct list *batteries, int show_empty_slots, int
 	    fields = list_next(fields);
 	}
 	if (type_battery) {	/* or else this is the ac_adapter */
+	    /* this does not work, see workaround below */
 	    if (!state) {
 		if (show_empty_slots) 
 		    printf("%s %d: slot empty\n", BATTERY_DESC, battery_num - 1);
@@ -411,6 +414,10 @@ void print_battery_information(struct list *batteries, int show_empty_slots, int
 	    }
 	    battery_num++;
 	}
+	/* this is a workaround: differently from /sys/class/power_supply/AC,
+	   /sys/class/power_supply/BAT0 exists only if a battery is present */
+	if (show_empty_slots && battery_num != type_total)
+	    printf("%s %d: slot empty\n", BATTERY_DESC, battery_num - 1);
 	battery = list_next(battery);
     }
 }
-- 
1.7.4.1

